<?php
/*
Plugin Name:    wsl-gallery gimmicks
Plugin URI:     http://www.wiesel.lu/wordpress/gallery-gimicks/
Version:        0.3.2
Description:    A Gallery offering different ways to watch your images. Typical Tag [wsl-gallery pictures="4096,4106,1564, 2552, 1862" view="synoptic" ]
Author: Daniel Erpelding
Author URI:     http://www.wiesel.lu/


*/


add_shortcode('wsl-picture','wsl_picture');

function wsl_picture($attr,$content){
    global $post;
    // kostenlose Zugabe.
    // see http://codex.wordpress.org/Template_Tags/wp_get_attachment_link
    extract(shortcode_atts(array(
		'id'         => $post->ID,
        'latest'     => null,
        'oldest'     => null,
        'show_title' => null,
		'size'       => 'thumbnail',
        'permalink'  => true,
        'icon'       => false,
	), $attr));
    if ($latest or $oldest){ 
        //SELECT MAX(column_name) FROM table_name
        if (isset($latest)) {
            $orderby = $latest;
            $order   = 'DESC';
        }else{
            $orderby = $oldest;
            $order   = 'ASC';
        }
        //$order  = ($lastest!=null) ? :
        //$out .= "<p>Latest: $latest or Oldest $oldest Order: ".$order."</p>";
        $images = get_children('post_parent='.$id.'&post_type=attachment&post_mime_type=image&orderby='.$orderby.'&order='.$order);
        //echo "<pre>";print_r($images);echo "</pre>";
        $keys   = array_keys($images);
        $id     = $images[$keys[0]]->ID;
        $title  = $images[$keys[0]]->post_title;
    }
    if ($show_title=='above') {$out.= "<p>".$title."</p>";}
    $out.=wp_get_attachment_link($id, $size, $permalink, $icon);
    if ($show_title=='below') {$out.= "<p>".$title."</p>";}
    return $out;
}

// adding the shortcode to wordpress
add_shortcode ('wsl-gallery','wsl_gallery');


function wsl_gallery ($attr,$content){
    //do_shortcode( $content );
    global $post, $wpdb;
    extract(shortcode_atts(array(
		'id'         => $post->ID,
        'view'       => 'synoptic',
        'pictures'   => null,               //leave this blank, if your images are children to the post $id, or provide a comma separated list, with the image ID's
        'orderby'    => 'excerpt',     
        'order'      => 'ASC',
        'subpages'   => false,
        'limit'      => false,
	), $attr));
    
    if (isset($_GET['orderby'])) {$orderby=$_GET['orderby'];}
    if (isset($_REQUEST['order'])) {$order=$_REQUEST['order'];}
    $orderby =fieldname_orderby($orderby);
    //echo "IDS:". $orderby.$pictures;
    if ($pictures!=null) {
        //echo "IDA";
        $IDS_array = explode(",",$pictures);
        $where_clause= "";
        $i=0;
        foreach ($IDS_array as $pic_id){
            if ($i!=0) {
                $where_clause .= " or ";
            }
            $where_clause .= "wposts.ID = ".$pic_id;
            $i++;
        }
        $orderby_clause = "";//($orderby=='menu_order')? "" : " ORDER BY wposts.".$orderby." ".$order;;
    }else{
        $where_clause   = "((wposts.post_parent = ".$id.") ";
        if ($subpages==true) {
            if (($children=wsl_childpages($id))!=false) {
                foreach ($children as $child){
                    $where_clause   .= " OR (wposts.post_parent = ".$child->ID.") ";
                }
            }

        }
        $where_clause   .= ") ";
        $orderby_clause = " ORDER BY wposts.".$orderby." ".$order;
    }
    
        
    $querystr = "
    SELECT wposts.* 
    FROM $wpdb->posts wposts
    WHERE ".$where_clause." 
    AND wposts.post_type = 'attachment'"
    .$orderby_clause;
    if ($limit) {
        $querystr .= " LIMIT ".$limit;
    }
    //echo "The SQL: $querystr";
    $attachments = $wpdb->get_results($querystr, OBJECT);
    //echo "<pre>";print_r($attachments); echo "</pre>";

    // Now, we have the ordered attachments array, lets see what is in
    if ( empty($attachments) )
        return '';
    // ok, we have pictures! now, lets display the choices we have in the way, to look them
    return gallery_views_switcher($attachments,$attr,$content);
    
}
function gallery_views_switcher($attachments,$attr,$content){
    global $post, $wpdb;
    extract(shortcode_atts(array(
        //'id'         => $post->ID,
        'view'       => 'synoptic',
        'other_views'=> 'show',
        'views'      => 'all',
        //'orderby'    => 'post_excerpt',     
        'order'      => 'ASC',
        'link2'      => 'page',
        'size'       => 'thumbnail',
        'permalink'  => true,
        'icon'       => false,

    ), $attr));
    if (isset($_REQUEST['view']))   {$view  =$_REQUEST['view'];} // REQUEST can override shortcode parameter
    if (isset($_REQUEST['views']))  {$views =$_REQUEST['view'];} // REQUEST can override shortcode parameter
    if (isset($_REQUEST['order']))  {$order =$_REQUEST['order'];}
    $possible_views=array(
            'intro'     =>array(
                'key'   =>'intro',
                'text'  =>'intro'),
            'alphabetic'    =>array(
                'key'   =>'alphabetic',
                'text'  =>'alphabetic'),
            'details'   =>array(
                'key'   =>'details',
                'text'  =>'in detail'),
            'synoptic'  =>array(
                'key'   =>'synoptic',
                'text'  =>'synoptic'),
            'gallery'   =>array(
                'key'   =>'gallery',
                'text'  =>'gallery'),
            );
    if ($views=='all') {
        $available_views=$possible_views;
    }else{
        $dustbin = explode(",",$views);
        foreach ($dustbin as $v){
            $thisview =trim($v);
            if (isset($possible_views[$thisview])) {
                $available_views[$thisview] = $possible_views[$thisview];
            }
        }
    }
    
    if ($other_views=='show') {
        // [intro|alphabethisch|detailiert|synoptisch]
        
        if (empty($content)) {
            unset($available_views['intro']);
        }
        $out .= "<p>[";
        $i=0;
        foreach ($available_views as $thisview){
            if ($i!=0) { $out .= "|";}
            if ($view!=$thisview['key']) {
                $out .= "<a href=\"?view=".$thisview['key']."\">".$thisview['text']."</a>";
            }
            else $out .= $thisview['text'];
            $i++;
        }
        $out .= "]</p>";
        
    }
    
    switch ($view) {
    case 'intro':
        $out .=  do_shortcode($content);
        break;
    case 'synoptic':
        $out .=  list_synoptic($attachments,$attr);
        break;
    case 'alphabetic':
        $out .=  list_abc($attachments,$attr);
        break;
    case 'details':
        $out .= list_with_details($attachments,$attr);
        break;
    case 'gallery':
        $out .=  gallery_copy($attachments,$attr);
        break;
    }
    return $out;
}

function list_with_details($attachments,$attr){
    extract(shortcode_atts(array(
		'link2'              => 'page',
        'linkcolumn'         => 'post_title',
        'details_columns'    => 'ID,title,mediatags,modified',
        'orderby'            => 'post_excerpt',
        'name'               => '',

	), $attr));

    //$orderby=fieldname_orderby($orderby);
    if ((fieldname_orderby($orderby)=='post_title') or (fieldname_orderby($orderby)=='post_excerpt')) {
        $out=firstletter_links($attachments,fieldname_orderby($orderby));
    }
    $flag_mediatags= function_exists('mediatags_get_fields');
    $columns=explode(",",$details_columns);
    //echo "<pre>";print_r($columns); echo "</pre>";
    // first pass: build an array
    $array=array();
    $i=0;
    foreach ($attachments as $set){
        $id=$set->ID;
        $metakeys   =get_post_custom_keys($id);
        //$metavals   =get_post_custom_values($key, $post_id);
        $meta = wp_get_attachment_metadata($id, false);
        //if ($i<6) {
        //    echo "<pre>";print_r($set); echo "</pre>";
        //    echo "<pre>";print_r($metakeys); echo "</pre>";
        //    echo "<pre>";print_r($meta); echo "</pre>";
        //}
        $array[$i]['ID'] = $set->ID; // immer!
        foreach($columns as $col){
            $field = fieldname_orderby($col);
            $array[$i][$col]= $set->$field;
            //echo "takling about $i $col: " . $set->$col;
        }
        $i++;
    }
    $flag_mediatags= function_exists('mediatags_get_fields');
    $out .="<table>\n";
    $out .="<tr>\n";
    foreach ($columns as $col){
        if ($col!='mediatags') {
            $out .= "\t\t<th>".$col. " ".orderlinks('details',$col)."</th>\n";
        }elseif ($flag_mediatags) {
            $out .= "\t\t<th>".$col."</th>\n";
        }
    }

    $out .="</tr>\n";
    $lastfirstletter=chr(ord("a")-1);
    $i=0;
    foreach ($array as $row){
        //if ($i==0) {echo "<pre>";print_r($row);echo "</pre>";}
        $out .="<tr>\n";
        $id = $row['ID'];
        foreach ($columns as $col){
            if ($col=='mediatags') {
                $text =media_tag_string($id);
            }elseif ($col==$linkcolumn) {
                $link = ($link2=='page') ? get_attachment_link($id) : $link2."".$id ;
                $text= "<a href=\"".$link."\">".$row[$col]."</a>";
            }else
                $text= $row[$col];
            $out .= "\t\t<td>";
            //$thisname = ;
            //echo "<p>col: $col - orderby: $orderby</p>";
            if ($col==$orderby) {
                $firstletter=firstletter($row[$col]);
            
                if (($firstletter>$lastfirstletter)&&(!($firstletter>"z"))) {
                
                $out .='<a name="'.$name.'_'.$firstletter.'"></a>';
                //$out .= "<h3>$firstletter</h3>\n";
                $lastfirstletter=$firstletter;
                }
            }

            $out .= $text."</td>\n";
        }
        $out .="</tr>\n";
        $i++;
    }
    $out .="</table>\n";
    return $out;
}

function list_abc($tables,$attr){
    extract(shortcode_atts(array(
		'link2'              => 'page',
        'name'               => '',
        'orderby'            => 'post_excerpt',
        'wordcount'          => 20,
	), $attr));
    $orderby =fieldname_orderby($orderby);
    //echo "Orderby: $orderby";
    $out .= firstletter_links($tables,$orderby);
    $words=0;
    $lastfirstletter=chr(ord("a")-1);
    foreach($tables as $key=>$table) {
        $id=$table->ID;
        $thisname = $table->$orderby;
        $firstletter=firstletter($thisname);
        if (($firstletter>$lastfirstletter)&&(!($firstletter>"z"))) {
            $out .='<a name="'.$name.'_'.$firstletter.'"></a>';
            $out .= "<h3>$firstletter</h3>\n";
            $lastfirstletter=$firstletter;
            $words=0;
        }else
            $out .= ", ";
        $words++;
         if ($words>$wordcount) {
              $words=0;
              $out .= "<br />";
         }
         $link = ($link2=='page') ? get_attachment_link($table->ID) : $link2."".$table->ID ;
         $out .= "<a href=\"".$link."\"  title=\"".$table->post_title."\" >".$table->post_title."</a>";
    }
    return $out;
}
function list_synoptic($attachments,$attr){
    extract(shortcode_atts(array(
		'link2'      => '?id=',
        'size'       => 'thumbnail',
        'show_id'    => null,
        'permalink'  => true,
        'icon'       => false,
        'orderby'    => 'excerpt',
        'name'       => '',

	), $attr));
    
    //$out= "<p>Schowdi = ".$show_id."</p>";
    $out .=firstletter_links($attachments,$orderby,$name);
   
    $out.="<table>\n";
    $i=1;
    $out .="\t<tr>\n";
    $out .="\t<th>".$i."</th>\n";
    if (current_user_can('edit_post')) {$out .="\t<th><a href=\"?orderby=ID\">ID</a></th>\n";}
    $out .="\t<th>Picture</th>\n";
    $out .="\t<th>Description".orderlinks('synoptic','excerpt')."</th>\n";
    $out .="\t</tr>\n";
    $lastfirstletter="@";
    foreach ($attachments as $set){
        $id=$set->ID;
        //if ($i==1) {  echo "<pre>";print_r($set); echo "</pre>";   }
        $txt = (current_user_can('edit_post'))? "<a href=\"/wp-admin/media.php?action=edit&attachment_id=".$id."\">".$i."</a>" : $i;
        $out .= "\t<tr>\n\t\t<th>".$txt."</th>\n";
        if (current_user_can('edit_post')) {
            $out .= "\t\t<td>".$id."</td>\n";
        }
        $pic  = isset($id)?wp_get_attachment_link($id, $size, $permalink, $icon):"";
        $out .= "\t\t<td>".$pic."</td>\n";
        $out .= "\t\t<td>";
        $fieldname = fieldname_orderby($orderby);
        $firstletter=firstletter($set->$fieldname);
        if (($firstletter>$lastfirstletter)&&(!($firstletter>"z"))) {
            $lastfirstletter=$firstletter;
            $out .="<a name=\"".$name."_".$firstletter."\"></a>";
        }
        $out .= "<h3>".wptexturize($set->post_title)."</h3>";
        $out .= wptexturize($set->post_content);
        if (($string=media_tag_string($id))!=false) {
            $out .="<p>Media-tagged with :".$string."</p>";
        }
        $out .= "</td>\n";
        $out .= "\t</tr>\n";
        $i++;
    }
    $out .= "</table>";
    return $out;
}
function gallery_copy($attachments, $attr=null){
    global $post;
    //echo "<pre>";print_r($attachments);echo "</pre>";
    
    static $instance = 0;
	$instance++;

	extract(shortcode_atts(array(
		'order'      => 'ASC',
		'orderby'    => 'menu_order',
		'itemtag'    => 'dl',
		'icontag'    => 'dt',
		'captiontag' => 'dd',
		'columns'    => 3,
		'size'       => 'thumbnail',
        'name'       => '',
	), $attr));
    $orderby = fieldname_orderby($orderby);
    if ( is_feed() ) {
		$out = "\n";
		foreach ( $attachments as $att_id => $attachment )
			$out .= wp_get_attachment_link($attachment->ID, $size, true) . "\n";
		return $out;
	}
    $out .= firstletter_links($attachments,$orderby);

	$itemtag = tag_escape($itemtag);
	$captiontag = tag_escape($captiontag);
	$columns = intval($columns);
	$itemwidth = $columns > 0 ? floor(100/$columns) : 100;

	$selector = "gallery-{$instance}";

	$out .= apply_filters('gallery_style', "
		<style type='text/css'>
			#{$selector} {
				margin: auto;
			}
			#{$selector} .gallery-item {
				float: left;
				margin-top: 10px;
				text-align: center;
				width: {$itemwidth}%;			}
			#{$selector} img {
				border: 2px solid #cfcfcf;
			}
			#{$selector} .gallery-caption {
				margin-left: 0;
			}
		</style>
		
		<div id='$selector' class='gallery galleryid-{$id}'>");

	$i = 0;
    $lastfirstletter ="@";
	foreach ( $attachments as $attachment ) {
        $id = $attachment->ID;
		$link = isset($attr['link']) && 'file' == $attr['link'] ? wp_get_attachment_link($id, $size, false, false) : wp_get_attachment_link($id, $size, true, false);

		$out .= "<{$itemtag} class='gallery-item'>";
        $thisname = $attachment->$orderby;
        $firstletter=firstletter($thisname);
        if (($firstletter>$lastfirstletter)&&(!($firstletter>"z"))) {
            $lastfirstletter=$firstletter;
            $out .="<a name=\"".$name."_".$firstletter."\"></a>";
        }
        $out .= "
			<{$icontag} class='gallery-icon'>
				$link
			</{$icontag}>";
        
		if ( $captiontag && trim($attachment->post_excerpt) ) {
			$out .= "
				<{$captiontag} class='gallery-caption'>
				" . wptexturize($attachment->post_excerpt) . "
				</{$captiontag}>";
		}
		$out .= "</{$itemtag}>";
		if ( $columns > 0 && ++$i % $columns == 0 )
			$out .= '<br style="clear: both" />';
	}

	$out .= "
			<br style='clear: both;' />
		</div>\n";

	return $out;
}
function firstletter($thisname){
    $firstletter=remove_accents(strtolower(substr($thisname,0,1)));
    //if (($firstletter=="") or ($firstletter=="")) {$firstletter="e";}
    
    return ($firstletter);
}
function orderlinks($view,$orderby){
     $out= "<a href=\"?view=".$view."&amp;orderby=".$orderby."&amp;order=ASC\">&uarr;</a>";
     $out .=" <a href=\"?view=".$view."&amp;orderby=".$orderby."&amp;order=DESC\">&darr;</a>";
     return $out;
}
function media_tag_string($id){
    if (!function_exists('mediatags_get_fields')) 
        return false;
     //found in medias_admin.php
    $media_tags_tmp 	= (array)wp_get_object_terms($id, MEDIA_TAGS_TAXONOMY);
    if (count($media_tags_tmp)>0) {
        //$out = "<p>Media tagged with :";
        foreach ($media_tags_tmp as $tag){
            $out .= "<a href=\"/media-tags/".$tag->slug."\">".$tag->name."</a>, ";
            }
        //$out .= "</p>\n";
        }
    return $out;        
}
// Bonus
add_shortcode('ln2img','wsl_link2pic');
function wsl_link2pic($attr,$content){
    extract(shortcode_atts(array(
		'id'         => null,
	), $attr));
    if (!empty($id)&&wp_attachment_is_image( $id )) {
        $url=get_attachment_link($id);
        $out ="<a href=\"".$url."\">".$content."</a>";
    }else 
        $out = $content;
    return $out;
}
add_shortcode('last-pictures','gallery_of_last_pictures');
function gallery_of_last_pictures($attr,$content){
    global $post;
    extract(shortcode_atts(array(
		'id'         => $post->ID,
        'limit'      => 6,
        ), $attr));
    $orderby='modified';
    $order= 'DESC';
    $string = 'post_parent='.$id.'&post_type=attachment&post_mime_type=image&orderby='.$orderby.'&order='.$order.'&limit='.$limit;
    $children = get_children($string);
    $i=0;
    $images=array();
    foreach ($children as $child ) {
        $images[$i]=$child;
        $i++;
        if ($i>=$limit) {
            break;
        }
    }
    return gallery_copy($images);
}
function wsl_childpages($id){
    global $post, $wpdb;
     $querystr = "
    SELECT wposts.ID 
    FROM $wpdb->posts wposts
    WHERE post_parent=".$id." 
    AND wposts.post_type = 'page'";
    $ids = $wpdb->get_results($querystr, OBJECT);
    if (count($ids)==0) {
        return false;
    }
    return $ids;
}
function firstletter_links($tables,$orderby,$name=""){
    //$out .="<p>JA, ich werde aufgerufen! Orderby: ".$orderby."</p>";
    //echo "<pre>";print_r($tables);echo "</pre>";
    $orderby = fieldname_orderby($orderby);
    $lastfirstletter=chr(ord("a")-1);
    $i=0;
    $out .="<p><a name=\"abcde\"></a>\n";
    foreach ($tables as $table){
        $thisname = $table->$orderby;
        $firstletter=firstletter($thisname);
        if (($firstletter>$lastfirstletter)&&(!($firstletter>"z"))) {
            $lastfirstletter=$firstletter;
            if ($i!=0) {
                $out .="|";
            }
            $out .="<a href=\"#".$name."_".$firstletter."\">".ucfirst($firstletter)."</a>\n";
            $i++;
        }
    }
    $out.="</p>\n";
    return $out;
}
function fieldname_orderby($orderby){
    $names = array(
        'author'     => "post_author"    , // Sort by the numeric author IDs.
        'category'   => "post_category"  , // Sort by the numeric category IDs.
        'content'    => "post_content"   , // Sort by content.
        'excerpt'    => "post_excerpt"   , // Sort by excerpt.
        'date'       => "post_date"      , // Sort by creation date.
        'ID'         => "ID"             , // Sort by numeric post ID.
        'menu_order' => "menu_order"     , // Sort by the menu order. Only useful with pages.
        'mime_type'  => "post_"          , // Sort by MIME type. Only useful with attachments.
        'modified'   => "post_modified"  , // Sort by last modified date.
        'name'       => "post_name"      , // Sort by stub.
        'parent'     => "post_parent"    , // Sort by parent ID.
        //, 'rand'       => "post_"        , // Randomly sort results.
        //, 'status'     => "post_"        , // Sort by status.
        'title'      => "post_title"     , // Sort by title.
        //, 'type'       => "post_"        , // Sort by type.
    );
    if (isset($names[$orderby])) {
        return($names[$orderby]);
    }else
        return $orderby;
}
?>
